/**
 * We are needing create embeds file for integration(asana, clickup, ...)
 * with name <integration_name>EmbedScripts.js on src/app/contentScript/v2/adaptor folder
 *
 * Inside we are declaring: var = embedMethods = {} and setting some methods for integration.
 * Gulp will build <integration_name>EmbedMethods.js + embedMethodScript.js to <integration_name>EmbedMethods.js
 * and then content script will be append this file in page.
 *
 *
 * We can call some embed method: embedMethod('someNameMethod', [someArgs])
 *
 * 'someNameMethod' is required
 * [someArgs] is optional
 *
 * */

var dictionary = null;
var DIC = (key) => {
    // console.log('Dictionary: ', dictionary, ' Key: ', key);
    return dictionary[key] || key;
};

document.addEventListener('embedMethod', (event) => {
    if ((!event.detail) || (event.detail && !event.detail.name)) {
        return;
    }

    try {
        if (!dictionary) {
            dictionary = event.detail.dict ? JSON.parse(event.detail.dict) : {};
        }

        const result = embedMethods[event.detail.name].apply(this, event.detail.args ? JSON.parse(event.detail.args) : null);

        document.documentElement.setAttribute(event.detail.name.toLowerCase(), JSON.stringify(result));
    } catch (err) {
        console.log(`[EV][embedMethod] ${event.detail.name} is fail `, err);
    }
});
